/*
 * About the wrapper handle and the intermediate handle...
 * The wrapper handle, obtained from NDIS, is the original of the driver.
 * Without this wrapper handle, we cannot do anything.
 * Unfortunately, we cannot get sufficient argument from USB loader to
 * ask one wrapper handle.
 * Current alternative is, to put this driver into NDIS registry as
 * it is a 'static' driver, thus, we can get the wrapper handle.
 * This wrapper handle should not be cleared even the USB device is plug'd
 * out. Or we cannot restart the NDIS function anymore.
 *
 */
#pragma warning(disable:4214 4115 4201 4127  4100 4510 4512 4610 4189)
#include <Usbdrv.h>
#include	"dm9usb.h"

int g_DriverMiniportInitializeCount= 0;

NIC_DRIVER_USB::NIC_DRIVER_USB(
		NDIS_HANDLE 			MiniportHandle, 
		NDIS_HANDLE 			WrapperConfigHandle,
		USB_HANDLE 				hDevice, 
		LPCUSB_FUNCS			lpUsbFuncs, 
		LPCUSB_DEVICE			lpUsbDevice,
		LPCUSB_INTERFACE 		lpInterface)
		: NIC_DRIVER_OBJECT(MiniportHandle,WrapperConfigHandle)
{
	m_hUsbHandle = hDevice;
	m_lpUsbFuncs = lpUsbFuncs;
	m_lpUsbDevice = lpUsbDevice;
	m_lpUsbInterface = lpInterface;
}

NIC_DRIVER_USB::~NIC_DRIVER_USB(void)
{
	PRINTF(_T("usb96 deconstructor.\n"));
}


void NIC_DRIVER_USB::MiniportInitialize(
	OUT PNDIS_STATUS OpenErrorStatus,
	OUT PUINT SelectedMediaIndex, 
	IN PNDIS_MEDIUM MediaArray, 
	IN UINT MediaArraySize)
{
  //U32 flow;
	SETFNAME("NIC_DRIVER_USB::MiniportInitialize");
	//FUNCTION_ENTER_MSG();
	
	//PRINTF(_T("- dm96.NdisIMRegisterLayered Regtrd IntrMediate hdl --> DRIVER_USB::MiniportInitialize\r\n"));

	if(!m_pLower){
                PRINTF(_T("[DM962].DrvMiniportInitCnt(new dm96)= %d \r\n"), ++g_DriverMiniportInitializeCount);
		m_pLower = DeviceEntry(this,NULL);   // identical to "g_pnic_Alloc->m_pLower"
		PRINTF(_T("<<< dm96-sta-v270 >>> 'm_pLower' new (%x) "), m_pLower);
		PRINTF(_T("'m_pLower' OBJ + +o+\r\n"));
        }
        else{
		PRINTF(_T("[DM962].DrvMiniportInitCnt(keep)= %d \r\n"),++g_DriverMiniportInitializeCount);
		PRINTF(_T("<<< dm96-sta-v270 >>> 'm_pLower' keep old (%x) "), m_pLower);
		PRINTF(_T("'m_pLower' keep old OBJ + +o+\r\n"));
        }

	if(m_pLower)
                ;
	else
		THROW((ERR_STRING("NIC_DRIVER_USB::MiniportInitialize - Error in creating device\r\n")));

	m_pLower->InitialUsbParameters(m_hUsbHandle,m_lpUsbFuncs,m_lpUsbInterface);
	NIC_DRIVER_OBJECT::MiniportInitialize(
		OpenErrorStatus,
		SelectedMediaIndex, 
		MediaArray, 
		MediaArraySize);
	//FUNCTION_LEAVE_MSG();
}

void NIC_DRIVER_USB::DriverOnUsbNotify(U32 uCode)
{
	NdisIMDeInitializeDeviceInstance(m_hMiniportAdapter);
}




