
#pragma warning(disable:4214 4115 4201 4127  4100 4510 4512 4610 4189 4611 4706 4701)
#include	"stdAfx.h"
#include	"exception.h"
#include	"mutex.h"
#include	"queue.h"
#include	"driver.h"
#include	"usbdrv.h"
#include	"ver.h"


//==============================================================================
//#define	USBDRV_ENTRY_RELEASE				_T("2007-12-13 20:00")
//==============================================================================
#define USBDRV_DEVICE_NAME					_T("DM9USB")
#define USBD_LIBRARY_NAME					_T("USBD.DLL")
#define	USBD_REGISTER_CLIENT_DRIVER_ID		_T("RegisterClientDriverID")
#define	USBD_REGISTER_CLIENT_SETTINGS		_T("RegisterClientSettings")
#define	USBD_UN_REGISTER_CLIENT_DRIVER_ID	_T("UnRegisterClientDriverID")
#define	USBD_UN_REGISTER_CLIENT_SETTINGS	_T("UnRegisterClientSettings")


#ifdef	__cplusplus
extern "C" {	// miniport driver trunk functions
#endif

USB_HANDLE 			g_hDevice; // jaeyoon
LPCUSB_FUNCS		g_lpUsbFuncs; // jaeyoon

LPCWSTR				g_lpszDriverID = USBDRV_DEVICE_NAME; 
NDIS_HANDLE			g_hNdisIntermediateHandle=NULL;
UNICODE_STRING		g_strRegistryPath; 	
int					g_nInstance=0;

LPCUSB_DEVICE		g_lpUsbDevice;
LPCUSB_INTERFACE 	g_lpInterface;
int					g_mode_962;   // 0 for dm961 mode, 1 for dm962 mode, {mode_9620}

int DriverEntryNewObj= 0;
NIC_DRIVER_USB *g_pnic_Alloc= 0;  // V270
int g_UsbEntryAttachedCount= 0;


extern "C" BOOL WINAPI	USBNotificationRoutine(
	LPVOID	lpNotifyParam,
	DWORD	dwCode,
	LPDWORD	pdw1,
	LPDWORD	pdw2,
	LPDWORD	pdw3,
	LPDWORD	pdw4)
{
	((NIC_DRIVER_USB*)lpNotifyParam)->DriverOnUsbNotify(dwCode);
	g_nInstance--;
	return TRUE;
}


extern "C" WORD GetUsbProductId();
extern "C" WORD GetUsbVendorId();
extern "C" WORD GetUsbReleaseNumber();
extern "C" void USBDriverSetting(USB_DRIVER_SETTINGS * pUsbDriverSettings);


extern "C" BOOL USBInstallDriver(LPCWSTR lpszDriverName)
{
	int		nRet;

	if (1) //mode_9620 -show-InstallDriver
	{
		_RPT_STRN(_T("mode_962 ( USB InstallDriver Enter.. )"));
	}
	SETFNAME("USBInstallDriver\r\n");

	HINSTANCE hUsbdInstance = LoadLibrary(USBD_LIBRARY_NAME);
	LPREGISTER_CLIENT_DRIVER_ID pRegisterClientDriverID = NULL;
	LPREGISTER_CLIENT_SETTINGS pRegisterClientSettings = NULL;
	
	// register unique client driver identifier
	if (hUsbdInstance)
	{
		pRegisterClientDriverID =
			(LPREGISTER_CLIENT_DRIVER_ID) GetProcAddress(hUsbdInstance,USBD_REGISTER_CLIENT_DRIVER_ID);

		pRegisterClientSettings =
			(LPREGISTER_CLIENT_SETTINGS) GetProcAddress(hUsbdInstance,USBD_REGISTER_CLIENT_SETTINGS);
	}

	if (pRegisterClientDriverID == NULL || pRegisterClientSettings ==NULL)
	{
		DEBUG_PRINTF(_T("USBInstallDriver::Can't get the USBD function pointer.\r\n"));
		//FUNCTION_LEAVE_MSG();			
		return FALSE;
	}

	nRet = pRegisterClientDriverID(g_lpszDriverID);
		
	// sets up the LoadClients registry keys
	USB_DRIVER_SETTINGS	usbDriverSettings;
	USBDriverSetting(&usbDriverSettings);  // 961 pack-info
	
	if (g_mode_962) //mode_9620 -show-InstallDriver
	{
	  // {Have solution in 'USBDriverSetting/GetUsbProductId()'}
	  //  usbDriverSettings.dwProductId = 0x9620; 
	  _RPT_STRN(_T("mode_962 ( Func: USBInstallDriver )"));
	  _RPT_STRN(_T("mode_962 ( PID= %x, USBInstall= %s )"), usbDriverSettings.dwProductId, lpszDriverName);
	}
	
	nRet = pRegisterClientSettings(lpszDriverName, g_lpszDriverID, NULL, &usbDriverSettings);

	if (hUsbdInstance)
		FreeLibrary(hUsbdInstance);
	
	DEBUG_PRINTF(_T("USBInstallDriver:%d\n"), nRet);
	//FUNCTION_LEAVE_MSG();
	if(!nRet) 
		return FALSE;
	return	TRUE;
}


extern "C" BOOL USBUnInstallDriver(void)
{
	SETFNAME("USBUnInstallDriver\r\n");
	BOOL fRet;

	USB_DRIVER_SETTINGS usbDriverSettings;
	HINSTANCE hUsbdInstance = LoadLibrary(USBD_LIBRARY_NAME);
	LPUN_REGISTER_CLIENT_DRIVER_ID pUnRegisterClientDriverID = NULL;
	LPUN_REGISTER_CLIENT_SETTINGS pUnRegisterClientSettings = NULL;
	
	//FUNCTION_ENTER_MSG();
	if (hUsbdInstance)
	{
		pUnRegisterClientDriverID =
			(LPUN_REGISTER_CLIENT_DRIVER_ID) GetProcAddress(hUsbdInstance,USBD_UN_REGISTER_CLIENT_DRIVER_ID);

		pUnRegisterClientSettings =
			(LPUN_REGISTER_CLIENT_SETTINGS) GetProcAddress(hUsbdInstance,USBD_UN_REGISTER_CLIENT_SETTINGS);
	}	


	if (pUnRegisterClientDriverID == NULL || pUnRegisterClientSettings ==NULL)
	{
		DEBUG_PRINTF(_T("USBUnInstallDriver::Can't get the USBD function pointer.\r\n"));
		//FUNCTION_LEAVE_MSG();		
		return FALSE;	
	}
	
if (g_mode_962) //mode_9620 -show-UnInstallDriver
{
  _RPT_STRN(_T("mode_962 ( Func: USBUnInstallDriver )"));
//_RPT_STRN(_T("mode_962 ( PID= %x )"), usbDriverSettings.dwProductId  <-- 'uninitialized local variable' );
}
	USBDriverSetting(&usbDriverSettings);

	fRet = pUnRegisterClientSettings( g_lpszDriverID, NULL, &usbDriverSettings);

	fRet = fRet & pUnRegisterClientDriverID( g_lpszDriverID );
	
	if (hUsbdInstance)
		FreeLibrary(hUsbdInstance);

	DEBUG_PRINTF(_T("USBUnInstallDriver:%d\n"), fRet);
	//FUNCTION_LEAVE_MSG();
	return fRet;
}

extern "C" NTSTATUS PostDriverEntry(
	USB_HANDLE 				hDevice, 
	LPCUSB_FUNCS			lpUsbFuncs, 
	LPCUSB_DEVICE			lpUsbDevice,
	LPCUSB_INTERFACE 		lpInterface)
{
	PRINTF(_T("dm96-AttPostEntry hdl %x \r\n"), g_hNdisIntermediateHandle);	
	if(!g_hNdisIntermediateHandle) return NDIS_STATUS_FAILURE;
	
	g_hDevice = hDevice;
	g_lpUsbFuncs = lpUsbFuncs;
	g_lpUsbDevice = lpUsbDevice;
	g_lpInterface = lpInterface;
	
	NDIS_STATUS		status;
	PRINTF(_T("dm96-AttPostEntry IniInstEx.s\r\n"));
	if((status = NdisIMInitializeDeviceInstanceEx(
		g_hNdisIntermediateHandle,
		&g_strRegistryPath,
		NULL
		) != NDIS_STATUS_SUCCESS))
	{
		PRINTF(_T("dm96-AttPostEntry IniInstEx.e %x, fail\r\n"), status);	
		return status;
	}
	PRINTF(_T("\r\n"));
	PRINTF(_T("dm96-AttPostEntry IniInstEx.e Succ(%x)\r\n"), NDIS_STATUS_SUCCESS);	
    return NDIS_STATUS_SUCCESS;
}

void wtoc(char *Dest, const WCHAR *Source)
{
	int i= 0;
	while (Source[i] != '\0')
	{
		Dest[i]= (char) Source[i];
		i++;
	}
	Dest[i]= '\0';
}

int wstr2char(char *Dest, const WCHAR *Source)
{
	int len= wcslen(Source); // CE API
	WCHAR wc;
	while (wc= *Source++)
	  *Dest++= (char) wc;
	*Dest++= '\0';
	return len;
}

#define DUMP_USB_DEVICE_DESCRIPTOR(i) { \
   PRINTF( _T("USB_DEVICE_DESCRIPTOR:\r\n")); \
   PRINTF( _T("-------------------------\r\n")); \
   PRINTF( _T("bLength: 0x%x\r\n"), i.bLength ); \
   PRINTF( _T("bDescriptorType: 0x%x\r\n"), i.bDescriptorType ); \
   PRINTF( _T("bcdUSB: 0x%x\r\n"), i.bcdUSB ); \
   PRINTF( _T("bDeviceClass: 0x%x\r\n"), i.bDeviceClass ); \
   PRINTF( _T("bDeviceSubClass: 0x%x\r\n"), i.bDeviceSubClass ); \
   PRINTF( _T("bDeviceProtocol: 0x%x\r\n"), i.bDeviceProtocol ); \
   PRINTF( _T("bMaxPacketSize0: 0x%x\r\n"), i.bMaxPacketSize0 ); \
   PRINTF( _T("idVendor: 0x%x\r\n"), i.idVendor ); \
   PRINTF( _T("idProduct: 0x%x\r\n"), i.idProduct ); \
   PRINTF( _T("bcdDevice: 0x%x\r\n"), i.bcdDevice ); \
   PRINTF( _T("iManufacturer: 0x%x\r\n"), i.iManufacturer ); \
   PRINTF( _T("iProduct: 0x%x\r\n"), i.iProduct ); \
   PRINTF( _T("iSerialNumber: 0x%x\r\n"), i.iSerialNumber ); \
   PRINTF( _T("bNumConfigurations: 0x%x\r\n"), i.bNumConfigurations ); \
   PRINTF( _T("\r\n"));  \
} 
#define DUMP_USB_CONFIGURATION0_DESCRIPTOR(i) { \
   PRINTF( _T("USB_CONFIGURATION0_DESCRIPTOR:\r\n")); \
   PRINTF( _T("-------------------------\r\n")); \
   PRINTF( _T("bLength: 0x%x\r\n"), i.bLength ); \
   PRINTF( _T("bDescriptorType: 0x%x\r\n"), i.bDescriptorType ); \
   PRINTF( _T("wTotalLength: 0x%x\r\n"), i.wTotalLength ); \
   PRINTF( _T("bNumInterfaces: 0x%x\r\n"), i.bNumInterfaces ); \
   PRINTF( _T("bConfigurationValue: 0x%x\r\n"), i.bConfigurationValue ); \
   PRINTF( _T("iConfiguration: 0x%x\r\n"), i.iConfiguration ); \
   PRINTF( _T("bmAttributes: 0x%x\r\n"), i.bmAttributes ); \
   PRINTF( _T("MaxPower: 0x%x\r\n"), i.MaxPower ); \
   PRINTF( _T("\r\n"));  \
} 

#define DUMP_USB_INTERFACE_DESCRIPTOR( i, _index ) { \
   PRINTF( _T("USB_INTERFACE_DESCRIPTOR[%d]:\r\n"), _index ); \
   PRINTF( _T("-------------------------\r\n")); \
   PRINTF( _T("bLength: 0x%x\r\n"), i.bLength ); \
   PRINTF( _T("bDescriptorType: 0x%x\r\n"), i.bDescriptorType ); \
   PRINTF( _T("bInterfaceNumber: 0x%x\r\n"), i.bInterfaceNumber ); \
   PRINTF( _T("bAlternateSetting: 0x%x"), i.bAlternateSetting ); \
   if (i.bInterfaceClass==0xa) \
	  PRINTF( _T(" (Alternation Setting%d)"), i.bAlternateSetting ); \
   PRINTF( _T("\r\n"));  \
   PRINTF( _T("bNumEndpoints: 0x%x\r\n"), i.bNumEndpoints ); \
   PRINTF( _T("bInterfaceClass: 0x%x"), i.bInterfaceClass ); \
   if (i.bInterfaceClass==0) PRINTF( _T(" (Null Class)")); \
   if (i.bInterfaceClass==2) PRINTF( _T(" (Comm Intf & CDC-Ctl)")); \
   if (i.bInterfaceClass==0xa) PRINTF( _T(" (CDC-Data Intf)")); \
   PRINTF( _T("\r\n"));  \
   PRINTF( _T("bInterfaceSubClass: 0x%x\r\n"), i.bInterfaceSubClass ); \
   PRINTF( _T("bInterfaceProtocol: 0x%x\r\n"), i.bInterfaceProtocol ); \
   PRINTF( _T("iInterface: 0x%x\r\n"), i.iInterface ); \
   PRINTF( _T("\r\n"));  \
}
   
#define DUMP_USB_ENDPOINT_DESCRIPTOR( e ) { \
   PRINTF( _T("USB_ENDPOINT_DESCRIPTOR: Endpoint %d\r\n"), e.bEndpointAddress&0xf); \
   PRINTF( _T("-----------------------------\r\n")); \
   PRINTF( _T("bLength: 0x%x\r\n"), e.bLength ); \
   PRINTF( _T("bDescriptorType: 0x%x\r\n"), e.bDescriptorType ); \
   PRINTF( _T("bEndpointAddress: 0x%x\r\n"), e.bEndpointAddress ); \
   PRINTF( _T("bmAttributes: 0x%x\r\n"), e.bmAttributes ); \
   PRINTF( _T("wMaxPacketSize: 0x%x\r\n"), e.wMaxPacketSize ); \
   PRINTF( _T("bInterval: 0x%x\r\n"), e.bInterval );\
   PRINTF( _T("\r\n")); \
}

DWORD Attach_DeviceReadPort(USB_HANDLE hUsbHandle, LPCUSB_FUNCS lpUsbFuncs, DWORD uPort)
{
	U32	val=0;

//	ENTER_CRITICAL_SECTION
//	VALIDATE_ADDR_PORT(uPort);

	USB_DEVICE_REQUEST	urb;
	
	urb.bmRequestType = 
		USB_REQUEST_VENDOR | USB_REQUEST_DEVICE_TO_HOST;
	urb.bRequest = 0x00;	// Read_Register
	urb.wValue = 0;
	urb.wIndex = (WORD)(uPort & 0xFF);
	urb.wLength = sizeof(char);
		
	USB_HANDLE	uhandle;
	uhandle = (*lpUsbFuncs->lpIssueVendorTransfer)(
		hUsbHandle,	// USB device handle
		NULL,			// callback address
		NULL,			// callback parameter
		USB_IN_TRANSFER,// flags
		&urb,			// request header
		(PVOID)&val,	// data buffer(if any)
		0);				// physical address
		
	if(!uhandle) return (DWORD)-1;

	DWORD	count,err;
	if(!(*lpUsbFuncs->lpGetTransferStatus)(uhandle,&count,&err) ||
		(err != 0) ) 
	{
//		BREAK; 
		val = (DWORD)-1;
	}

	(*lpUsbFuncs->lpCloseTransfer)(uhandle);

//	LEAVE_CRITICAL_SECTION
	return (DWORD)val;
}

DWORD Attach_DeviceWritePort(USB_HANDLE hUsbHandle, LPCUSB_FUNCS lpUsbFuncs, DWORD dwPort, DWORD dwValue)
{
	DWORD dwRet=dwValue;
//	VALIDATE_ADDR_PORT(dwPort);
	USB_DEVICE_REQUEST	urb;
	
	urb.bmRequestType = USB_REQUEST_VENDOR;	
	urb.bRequest = 0x03;	// Write1_Register
	urb.wValue = (WORD)(dwValue & 0xFF);
	urb.wIndex = (WORD)(dwPort & 0xFF);
	urb.wLength = 0x00;
		
	USB_HANDLE	uhandle;
	uhandle = (*lpUsbFuncs->lpIssueVendorTransfer)(
		hUsbHandle,// USB device handle
		NULL,		// callback address
		NULL,		// callback parameter
		0,			// flags
		&urb,		// request header
		NULL,		// data buffer(if any)
		0);			// physical address
		
	if(!uhandle) return (DWORD)-1;
	
	U32	count,err;
	if(!(*lpUsbFuncs->lpGetTransferStatus)(uhandle,&count,&err) ||
		(err != 0) ) 
		dwRet = (DWORD)-1;
	
	(*lpUsbFuncs->lpCloseTransfer)(uhandle);
	return dwRet;
}

extern "C" BOOL USBDeviceAttach(
	USB_HANDLE 				hDevice, 
	LPCUSB_FUNCS			lpUsbFuncs, 
	LPCUSB_INTERFACE 		lpInterface, 
	LPCWSTR 				szUniqueDriverId, 
	LPBOOL 					fAcceptControl, 
	LPCUSB_DRIVER_SETTINGS 	lpDriverSettings, 
	DWORD 					dwUnused )
{
	int m, n;
	DWORD dat;
	//+ LEE JAEYOON(20111128) Add
	//if (DriverEntryNewObj==0)
	//{
	//	Sleep(500);
	//}
	//- LEE JAEYOON(20111128)
	
	PRINTF(_T("\r\n"));
	PRINTF(_T("\r\n"));
	PRINTF(_T("- - -  - - - mode_962 ( USBDeviceAttach Enter.s.. ) - - - - - - -  - - - \r\n"));
	if (DriverEntryNewObj==0) {
		_RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.e (False).. )"));
		return (*fAcceptControl=FALSE);
	}
	
	g_UsbEntryAttachedCount++;
	_RPT_STRN(_T("[DM962].UsbEntryAttachedCount= %d \r\n"), g_UsbEntryAttachedCount);

	//Param:	lpUsbFuncs, 
	//Param		m_lpUsbFuncs;
	// 802.3az:
	//  Reg 0x5C, 0x3F  ------------ DM9USB_REGISTER_TYPE;  in DM9USB.h
	//  Dat 0x02, | 0x80 (Enable)
	// CDC coerce to non-CDC:
	//  Reg 0x2A/0x2B, 0x91  ------------ DM9USB_REGISTER_TYPE;  in DM9USB.h  (DM9_REG91H for 0x91)
	//  Dat 0x1269,    | 0x80 & 0xef ( 0xA0 or 0x80 )

	DWORD dat0,dat1,dat2,dat3;
	dat0= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x5C);
	dat1= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x3f);
	dat2= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x2A);
	dat3= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x91);
	_RPT_STRN(_T("[DM962].UsbEntryAttached HERE CDC snooping check: %02x, %02x,  %02x, %02x\r\n"), dat0,dat1,dat2,dat3);

	//dat= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x5C);
	//if (dat==0x02) {
	//	dat= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x3f);
	//	dat |= 0x80;
	//	Attach_DeviceWritePort(hDevice, lpUsbFuncs, 0x3f, dat);
	//}

	dat= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x91);
	if (dat & 0x30) {
		Attach_DeviceWritePort(hDevice, lpUsbFuncs, 0x91, 0x80); // ( 0xA0? or 0x80 )
		_RPT_STRN(_T("[DM962].UsbEntryAttached HERE CDC snooping\r\n"));
	} else
		Attach_DeviceWritePort(hDevice, lpUsbFuncs, 0x91, 0x80);

	dat0= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x5C);
	dat1= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x3f);
	dat2= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x2A);
	dat3= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x91);
	_RPT_STRN(_T("[DM962].UsbEntryAttached HERE CDC snooping check: %02x, %02x,  %02x, %02x\r\n"), dat0,dat1,dat2,dat3);

	Attach_DeviceWritePort(hDevice, lpUsbFuncs, 0x00, 0x01);
	_RPT_STRN(_T("[DM962].NCR.Reset\r\n"));

	dat= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x5C);
	if (dat==0x02) {
		dat= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x3f);
		dat |= 0x80;
		Attach_DeviceWritePort(hDevice, lpUsbFuncs, 0x3f, dat);
		_RPT_STRN(_T("[DM962].UsbEntryAttached HERE 802.3az\r\n"));
	}

	dat0= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x5C);
	dat1= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x3f);
	dat2= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x2A);
	dat3= Attach_DeviceReadPort(hDevice, lpUsbFuncs, 0x91);
	_RPT_STRN(_T("[DM962].UsbEntryAttached HERE CDC snooping check: %02x, %02x,  %02x, %02x\r\n"), dat0,dat1,dat2,dat3);

//        _RPT_STRN(_T("   param ( hDevice: %x"), hDevice);
//        _RPT_STRN(_T("   param ( lpUsbFuncs: %x"), lpUsbFuncs);
//        _RPT_STRN(_T("   param ( lpInterface(or null): %x"), lpInterface);
//        _RPT_STRN(_T("   param ( szUniqueDriverId: %s"), szUniqueDriverId);

	LPCUSB_DEVICE		pusbdev;
	LPCUSB_INTERFACE	pusbif;

	*fAcceptControl = TRUE;

  //Add DUMP:
	DWORD dwNumInterfaces;

	// retrive device and interface information
	for(pusbif=lpInterface;!pusbif;)
	{
		if (pusbdev= lpUsbFuncs->lpGetDeviceInfo(hDevice))
		{
			  _RPT_STRN(_T("   param ( USB Class Code: 0x%02x\r\n"), pusbdev->Descriptor.bDeviceClass);

		  //DUMP of Active:
			  dwNumInterfaces = pusbdev->lpActiveConfig->dwNumInterfaces;
			  PRINTF(_T("- - -  - - - mode_962 ( Total Num Interfaces: %d ) - - - - - - -  - - - \r\n"), dwNumInterfaces);

			  if (pusbdev->Descriptor.bcdUSB==0x0200)
				  _RPT_STRN(_T("- - -  - - - mode_962 ( Product ID is DM%x, High Speed ) - - -"), pusbdev->Descriptor.idProduct);
			  else if (pusbdev->Descriptor.bcdUSB==0x0110)
				  _RPT_STRN(_T("- - -  - - - mode_962 ( Product ID is DM%x, Full Speed ) - - -"), pusbdev->Descriptor.idProduct);
			  else
				  _RPT_STRN(_T("- - -  - - - mode_962 ( Product ID is DM%x, Unknown USB Speed ) - - -"), pusbdev->Descriptor.idProduct);
				  
			  DUMP_USB_DEVICE_DESCRIPTOR(pusbdev->Descriptor);
			  DUMP_USB_CONFIGURATION0_DESCRIPTOR(pusbdev->lpConfigs->Descriptor);

			  for (n=0; n< (int)pusbdev->lpConfigs->dwNumInterfaces; n++)
			  {
			  	DUMP_USB_INTERFACE_DESCRIPTOR(pusbdev->lpConfigs->lpInterfaces[n].Descriptor, pusbdev->lpConfigs->lpInterfaces[n].Descriptor.bInterfaceNumber);
			  	for (m=0; m<pusbdev->lpConfigs->lpInterfaces[n].Descriptor.bNumEndpoints; m++)
			  	{
			  		DUMP_USB_ENDPOINT_DESCRIPTOR(pusbdev->lpConfigs->lpInterfaces[n].lpEndpoints[m].Descriptor);  //lpEndpoints
			  	}
			  }
		}
		if(!pusbdev)
		{
			  _RPT_STRN(_T("mode_962 ( lpGetDeviceInfo NULL ! )"));
			  return FALSE;
		}	
		if(!(pusbif = lpUsbFuncs->lpFindInterface(pusbdev,0,0)))
		{
			  _RPT_STRN(_T("mode_962 ( lpFindInterface NULL ! )"));
			  return FALSE;
		}
	} // of for pusbif
	
	// jaeyoon
	if(!(lpUsbFuncs->lpClearFeature(hDevice, 0, 0, 4096, 1, 0)))
	{
		_RPT_STRN(_T("mode_962 ( lpClearFeature NULL ! )"));
	}

	// if(!(lpUsbFuncs->lpSetFeature(hDevice, 0, 0, 4096, 1, 0)))
        // {
	//	_RPT_STRN(_T("mode_962 ( lpClearFeature NULL ! )"));
        // }
	// jaeyoon

	//_RPT_STRN(_T("mode_962 ( Func: USBDeviceAttach )"));
	//_RPT_STRN(_T("mode_962 ( ReadChip= %x,%x )"), pusbdev->Descriptor.idVendor, pusbdev->Descriptor.idProduct);

	// check vendor and product IDs
	//
	//if( (pusbdev->Descriptor.idVendor != GetUsbVendorId()) ||	
	//	(pusbdev->Descriptor.idProduct != GetUsbProductId())) 
	//	return FALSE;
	//

	if (1) //'mode_9620' -First-Init
	{
	  if (pusbdev->Descriptor.idVendor == GetUsbVendorId()) 
		  ;
	  else{
		  _RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.e (VID False).. )"));
		  return FALSE;
	  }
	  if (pusbdev->Descriptor.idProduct == 0x9620)
		  ;
	  else if (pusbdev->Descriptor.idProduct == 0x9621)
		  ;
	  else if (pusbdev->Descriptor.idProduct == 0x1269) // 9621A
		  ;
	  else{
		  _RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.e (PID False).. )"));
		  return FALSE;
	  }

	  //if( (pusbdev->Descriptor.idVendor != GetUsbVendorId()) ||	
		//  (pusbdev->Descriptor.idProduct != 0x9620 &&
		//   pusbdev->Descriptor.idProduct != 0x9621 &&
		//   pusbdev->Descriptor.idProduct != 0x1269)
		//  ) 
		//return FALSE;

	  g_mode_962= 0;
	  if (pusbdev->Descriptor.idProduct == 0x9620)
		  g_mode_962= 1;
	  if (pusbdev->Descriptor.idProduct == 0x9621)
		  g_mode_962= 1;
	  if (pusbdev->Descriptor.idProduct == 0x1269)
		  g_mode_962= 1;
	  //g_mode_962= 0;
	  //if (pusbdev->Descriptor.idProduct == 0x9620 || 
		//  pusbdev->Descriptor.idProduct == 0x9621 )
		//  g_mode_962= 1;

	  _RPT_STRN(_T("mode_962 ( Enter.e  ; rx_head %d B )"), 3+g_mode_962 ); // 3 OR 4 BYTES
	   PRINTF(_T("<<< dm96-st_v270 >>> ---------------- \r\n"));
	}
	
	unsigned short	wsz[16]; //unsigned short wsz[512];
	wsprintf(wsz,TEXT("%s%d"),szUniqueDriverId,++g_nInstance);
	NdisInitUnicodeString(&g_strRegistryPath, wsz);
	_RPT_STRN(_T("   param ( NdisInitUnicodeString: %s%d"), szUniqueDriverId, g_nInstance); 

//	if(PostDriverEntry(hDevice,lpUsbFuncs,pusbdev,pusbif)
//		!= NDIS_STATUS_SUCCESS) {
//		_RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.e (Post False).. )"));
//		return (*fAcceptControl=FALSE);
//	}
//  =
		PRINTF(_T("dm96-PostEntry IntdMedia hdl %x \r\n"), g_hNdisIntermediateHandle);
		if(!g_hNdisIntermediateHandle) {
			_RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.e (Post False-I)..)"));
			return (*fAcceptControl=FALSE);
		}
		g_hDevice = hDevice;
		g_lpUsbFuncs = lpUsbFuncs;
		g_lpUsbDevice = pusbdev;
		g_lpInterface = pusbif;
		if(NdisIMInitializeDeviceInstanceEx(  // -- > MiniportInitialize()
			g_hNdisIntermediateHandle,
			&g_strRegistryPath,
			NULL
			) != NDIS_STATUS_SUCCESS) {
			_RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.e (Post False-II)..)"));
			return (*fAcceptControl=FALSE);
		}

	_RPT_STRN(_T("mode_962 ( USBDeviceAttach Enter.E.. ) - - - "));
	PRINTF(_T("#\r\n"));
	PRINTF(_T("\r\n"));
	return *fAcceptControl;
}

NDIS_STATUS MiniportInitialize(
	OUT PNDIS_STATUS OpenErrorStatus,
	OUT PUINT SelectedMediaIndex, 
	IN PNDIS_MEDIUM MediaArray, 
	IN UINT MediaArraySize,
    IN NDIS_HANDLE MiniportHandle, 
	IN NDIS_HANDLE WrapperConfigHandle)
{
	SETFNAME("DM9::MiniportIntialize()");
	//FUNCTION_ENTER_MSG();

	NIC_DRIVER_USB	*pnic;

	//PRINTF(_T("dm96-v270 >>> ---------------- \r\n"));
	//PRINTF(_T("dm96-v270 >>> To start a CYCLE \r\n"));
	//PRINTF(_T("dm96-v270 >>> ---------------- \r\n"));
	
	if (g_pnic_Alloc){
		PRINTF(_T("<<< dm96-sta-v270 >>> =Check memory blocks= \r\n"));

		// Free the new & alloc memory
		PRINTF(_T("<<< dm96-sta-v270 >>> 'm_dwAddr_Alloc' tobekeep (%x) \r\n"), g_pnic_Alloc->m_dwAddr_Alloc);
		PRINTF(_T("<<< dm96-sta-v270 >>> 'm_pLower' tobekeep (%x) \r\n"), g_pnic_Alloc->m_pLower);
#if 0
	      //PRINTF(_T("<<< dm96-sta-v270 >>> 'm_dwAddr' found (%x), "), g_pnic_Alloc->m_dwAddr_Alloc);
	      //PRINTF(_T("'m_dwAddr' FREED - -m-\r\n"));
	      //free( (void *)g_pnic_Alloc->m_dwAddr_Alloc); // v.s. 'malloc'
	      //g_pnic_Alloc->m_dwAddr_Alloc= NULL;
#endif		
#if 0
	      //PRINTF(_T("<<< dm96-sta-v270 >>> 'm_pLower' found (%x), "), g_pnic_Alloc->m_pLower);
	      //PRINTF(_T("'m_pLower' DELETTED - -o-\r\n"));
	      //delete g_pnic_Alloc->m_pLower; // v.s. new
	      //g_pnic_Alloc->m_pLower= NULL; // mark jj2525
#endif
#if 0		
		PRINTF(_T("<<< dm96-sta-v270 >>> 'pnic' found (%x), "), g_pnic_Alloc);
		PRINTF(_T("'pnic' DELETTED - -ALL-\r\n"));
		delete g_pnic_Alloc; // v.s. new
		g_pnic_Alloc= 0; // leave. after all release
#endif
	}
	
	if (g_pnic_Alloc){
		PRINTF(_T("<<< dm96-sta-v270 >>> 'pnic' keep (%x), "), g_pnic_Alloc);
		PRINTF(_T("'pnic' KEEP + +ALL+\r\n"));
		
		pnic= g_pnic_Alloc;
		
		//	PRINTF(_T("+ NIC_DRIVER_OBJECT \r\n"));
			g_pnic_Alloc->m_hMiniportAdapter = MiniportHandle;
			g_pnic_Alloc->m_hWrapperConfiguration = WrapperConfigHandle;

			g_pnic_Alloc->m_fSystemHang = FALSE;
			g_pnic_Alloc->m_fOutOfResources = FALSE;
		//	m_pLower = NULL; // see jj2525
		//	PRINTF(_T("- NIC_DRIVER_OBJECT \r\n"));
	
		g_pnic_Alloc->m_hUsbHandle = g_hDevice;
		g_pnic_Alloc->m_lpUsbFuncs = g_lpUsbFuncs;
		g_pnic_Alloc->m_lpUsbDevice = g_lpUsbDevice;
		g_pnic_Alloc->m_lpUsbInterface = g_lpInterface;
	}
	
	if (!g_pnic_Alloc)
	{
	  if(!(pnic = new NIC_DRIVER_USB(
		MiniportHandle,

		WrapperConfigHandle,
		g_hDevice,
		g_lpUsbFuncs,
		g_lpUsbDevice,
		g_lpInterface)))
		return	NDIS_STATUS_FAILURE;
		
	  g_pnic_Alloc= pnic;  // V270
	  g_pnic_Alloc->m_dwAddr_Alloc= NULL;

	  PRINTF(_T("\r\n"));
	  PRINTF(_T("<<< dm96-sta-v270 >>> 'pnic' new (%x), "), g_pnic_Alloc);
	  PRINTF(_T("'pnic' CONSTRU + +ALL+\r\n"));
        }

	g_lpUsbFuncs->lpRegisterNotificationRoutine(
		g_hDevice,
		(LPDEVICE_NOTIFY_ROUTINE)USBNotificationRoutine,
		(LPVOID)pnic);

	CException	*pexp;
	TRY
	{
		PRINTF(_T("-  - - - - - Davicom-v281 (DRIVER_MiniportInitialize.s) - - - - -  - \r\n"));
		pnic->MiniportInitialize( // class NIC_DRIVER_USB:public NIC_DRIVER_OBJECT, NIC_DRIVER_USB::MiniportInitialize(-)
			OpenErrorStatus,
			SelectedMediaIndex, 
			MediaArray, 
			MediaArraySize);
		pnic->m_pLower->GetChipID(); // V270
			  //pnic->m_pLower->DeviceInitNotice(); // V281 
			  // (be done in 'DeviceStart', by 'DriverStart' by 'pnic->MiniportInitialize' by 'NDIS_STATUS MiniportInitialize()')
		PRINTF(_T("-  - - - - - Davicom-v281 (DRIVER_MiniportInitialize.e) - - - - -  - \r\n"));
		FI;
	}
	CATCH(pexp)
	{
		pexp->PrintErrorMessage();
		CLEAN(pexp);
		delete pnic;
		return NDIS_STATUS_FAILURE;
	}
	
	//FUNCTION_LEAVE_MSG();
	return NDIS_STATUS_SUCCESS;
}

#ifdef	__cplusplus   
}	// of miniport trunk functions
#endif

/********************************************************************************************
 *
 * DriverEntry
 *
 ********************************************************************************************/

extern "C" NTSTATUS DriverEntry(IN PDRIVER_OBJECT pDriverObject,IN PUNICODE_STRING pRegistryPath)
{
	NDIS_STATUS		status;
	NDIS_HANDLE		hwrapper;

	NDIS40_MINIPORT_CHARACTERISTICS	ndischar;

//	PRINTF(_T("( + DriverEntry.s )\r\n")); 

	DriverEntryNewObj= 1;
	PRINTF(_T("\r\n"));
	PRINTF(_T("[dm962: NewOBJ+2048+frees]\r\n"));
	PRINTF(_T("[dm962: Ver %s (USB2.0 Edtion)]\r\n"), DAVICOM_NIC_DRIVER_VERSION); //DAVICOM_NIC_DRIVER_VERSION( is _T("2.92") )
  //DEBUG_PRINTF(_T("\r\n"));
  //DEBUG_PRINTF(_T("==============================================\r\n"));
  //DEBUG_PRINTF(_T("Davicom Semiconductor, Inc.\r\n"));
  //DEBUG_PRINTF(_T("----------------------------------------------\r\n"));
  //DEBUG_PRINTF(_T("Based USBDrv Version : %s\r\n"),_DAVICOM_NIC_DRIVER_VERSION);
  //DEBUG_PRINTF(_T("USBDrv Release Date   : %s\r\n"),_DAVICOM_NIC_DRIVER_RELEASE);
  //DEBUG_PRINTF(_T("==============================================\r\n"));	 	

	NdisMInitializeWrapper(&hwrapper, pDriverObject, pRegistryPath,	NULL);

	memset((void*)&ndischar,0,sizeof(ndischar));
    
    ndischar.Ndis30Chars.MajorNdisVersion = PRJ_NDIS_MAJOR_VERSION;
	ndischar.Ndis30Chars.MinorNdisVersion = PRJ_NDIS_MINOR_VERSION;
    
	ndischar.Ndis30Chars.InitializeHandler			= MiniportInitialize;
    ndischar.Ndis30Chars.ResetHandler				= MiniportReset;
    ndischar.Ndis30Chars.CheckForHangHandler		= MiniportCheckForHang;
    ndischar.Ndis30Chars.HaltHandler				= MiniportHalt;
    ndischar.Ndis30Chars.HandleInterruptHandler		= MiniportInterruptHandler;
    ndischar.Ndis30Chars.ISRHandler					= MiniportISRHandler;
    ndischar.Ndis30Chars.QueryInformationHandler	= MiniportQueryInformation;
    ndischar.Ndis30Chars.SetInformationHandler		= MiniportSetInformation;
    ndischar.Ndis30Chars.SendHandler				= MiniportSend;


	if((status = NdisIMRegisterLayeredMiniport(
		hwrapper,
		(PNDIS_MINIPORT_CHARACTERISTICS)&ndischar,
		sizeof(ndischar),
		&g_hNdisIntermediateHandle ) != NDIS_STATUS_SUCCESS))
	{
		PRINTF(_T("DriverEntry -> NdisIMRegisterLayeredMiniport ->NdisTerminateWrapper.s \r\n"));
		NdisTerminateWrapper(hwrapper,NULL);
		PRINTF(_T("DriverEntry -> NdisIMRegisterLayeredMiniport ->NdisTerminateWrapper.e \r\n"));
		return status;
	}

#ifndef	IMPL_DLL_ENTRY	
	INIT_EXCEPTION();
#endif

	PRINTF(_T("- dm96.NdisIMRegisterLayered Regtrd IntrMediate hdl %x\r\n"), g_hNdisIntermediateHandle);
	PRINTF(_T("- DriverEntry.e \r\n"));
	PRINTF(_T("\r\n"));
    return NDIS_STATUS_SUCCESS;
}


