// device.cpp: implementation of the NIC_DEVICE_OBJECT class.
//
// Copyright (c) 2000-2007 Davicom Inc.  All rights reserved.
// 
//////////////////////////////////////////////////////////////////////

#pragma warning(disable:4100 4201 4201 4244 4127 4510 4512 4610 4611 4189 4706)
#include	"device.h"

#ifdef TARGET_DM96
#include "dm96.h"   //#include "dm9usb.h"
#endif


#ifdef	__cplusplus
extern "C" {	// miniport driver trunk functions
#endif
extern USB_HANDLE 		g_hDevice;
extern LPCUSB_FUNCS		g_lpUsbFuncs;  //g_hDevice, g_lpUsbFuncs

extern LPCUSB_DEVICE		g_lpUsbDevice;
#ifdef	__cplusplus   
}	// of miniport trunk functions
#endif
LPWSTR ModNameT[]= {
	_T("-HP Auto-MDIX mode"), // 0 (20.5|20.4=x0b)
	_T("-MDI mode"), // 1 (20.5|20.4=01b)
	_T("-MDIX mode"), // 2 (20.5|20.4=11b)
};
LPWSTR ModeNameTbl[]= {
	_T("-HP Auto-MDIX mode \r\n"), // 0 (20.5|20.4=x0b)
	_T("-MDI mode \r\n"), // 1 (20.5|20.4=01b)
	_T("-MDIX mode \r\n"), // 2 (20.5|20.4=11b)
};

LPWSTR LinkNameTbl[]= { /* Link Control Mode */
	WSTR("LINK AUTO"), // 0
	WSTR("LINK 10M Half"), // 1
	WSTR("LINK 10M Full"), // 2
	WSTR("LINK 100M Half"), // 3
	WSTR("LINK 100M Full"), // 4
	WSTR("LINK LoopBack"), // 5
};

LPWSTR SpeedNameTbl[]= {/* Link Speed Status */
	WSTR("SPEED NONE"), // 0
	WSTR("SPEED 10M Half"), // 1
	WSTR("SPEED 10M Full"), // 2
	WSTR("SPEED 100M Half"), // 3
	WSTR("SPEED 100M Full"), // 4
};


NIC_DEVICE_OBJECT::NIC_DEVICE_OBJECT(NIC_DRIVER_OBJECT*	pUpper,PVOID pVoid)
{
	int i;
//	PRINTF(_T("[DM962].NIC_DEVICE_OBJECT \r\n"));
//	PRINTF(_T("\r\n"));
	m_pUpper = pUpper;
	m_nResetCounts = 0;
	m_nMulticasts = 0;
	m_wLinkState = 0;

	m_CHIPMsgCtrl= FALSE;
	m_Counter_Mix= m_Counter_detch= m_Counter_Fail= m_Counter= 0;

//	PRINTF(_T("+ NIC_DEVICE_OBJECT \r\n"));
	memset((void*)&m_dwEepromFiledPosition,0,sizeof(m_dwEepromFiledPosition));
	memset((void*)&m_szStatistics,0,sizeof(m_szStatistics));
	memset((void*)&m_szLastStatistics,0,sizeof(m_szLastStatistics));
	memset((void*)&m_szConfigures,0xFF,sizeof(m_szConfigures));
	memset((void*)&m_szCurrentSettings,0,sizeof(m_szCurrentSettings));

#ifdef	IMPL_RESET
	m_fShutdown=FALSE;
#endif	

	//JJDBG_Init, Step-2 "Init"
	Li= 0; //sLen= 0;
	for (i=0;i<N_DBGCAP;i++){
	  cLen[i]= 0;
	  cLenCt[i]= 0;		
	}

//	PRINTF(_T("- NIC_DEVICE_OBJECT \r\n"));
}


NIC_DEVICE_OBJECT::~NIC_DEVICE_OBJECT()
{
}

/********************************************************************************
 *
 * CRC32 Routine
 *
 * This routine calculates the CRC based on the following polynominal
 *   x^32+x^26+x^23+x^22+x^16+x^12+x^11+x^10+x^8+x^7+x^5+x^4+x^2+x+1
 *
 * About the CRC value of one EEPROM
 *
 * eeprom<126-127> = CRC value = (U16)crc32(eeprom<0..125>);
 *
 *
 *
 *******************************************************************************/
#if LEGAL_PATENT
U32 g_szCRCTable[256] = {
   0x00000000L, 0x77073096L, 0xEE0E612CL, 0x990951BAL,
   0x076DC419L, 0x706AF48FL, 0xE963A535L, 0x9E6495A3L,
   0x0EDB8832L, 0x79DCB8A4L, 0xE0D5E91EL, 0x97D2D988L,
   0x09B64C2BL, 0x7EB17CBDL, 0xE7B82D07L, 0x90BF1D91L,
   0x1DB71064L, 0x6AB020F2L, 0xF3B97148L, 0x84BE41DEL,
   0x1ADAD47DL, 0x6DDDE4EBL, 0xF4D4B551L, 0x83D385C7L,
   0x136C9856L, 0x646BA8C0L, 0xFD62F97AL, 0x8A65C9ECL,
   0x14015C4FL, 0x63066CD9L, 0xFA0F3D63L, 0x8D080DF5L,
   0x3B6E20C8L, 0x4C69105EL, 0xD56041E4L, 0xA2677172L,
   0x3C03E4D1L, 0x4B04D447L, 0xD20D85FDL, 0xA50AB56BL,
   0x35B5A8FAL, 0x42B2986CL, 0xDBBBC9D6L, 0xACBCF940L,
   0x32D86CE3L, 0x45DF5C75L, 0xDCD60DCFL, 0xABD13D59L,
   0x26D930ACL, 0x51DE003AL, 0xC8D75180L, 0xBFD06116L,
   0x21B4F4B5L, 0x56B3C423L, 0xCFBA9599L, 0xB8BDA50FL,
   0x2802B89EL, 0x5F058808L, 0xC60CD9B2L, 0xB10BE924L,
   0x2F6F7C87L, 0x58684C11L, 0xC1611DABL, 0xB6662D3DL,
   0x76DC4190L, 0x01DB7106L, 0x98D220BCL, 0xEFD5102AL,
   0x71B18589L, 0x06B6B51FL, 0x9FBFE4A5L, 0xE8B8D433L,
   0x7807C9A2L, 0x0F00F934L, 0x9609A88EL, 0xE10E9818L,
   0x7F6A0DBBL, 0x086D3D2DL, 0x91646C97L, 0xE6635C01L,
   0x6B6B51F4L, 0x1C6C6162L, 0x856530D8L, 0xF262004EL,
   0x6C0695EDL, 0x1B01A57BL, 0x8208F4C1L, 0xF50FC457L,
   0x65B0D9C6L, 0x12B7E950L, 0x8BBEB8EAL, 0xFCB9887CL,
   0x62DD1DDFL, 0x15DA2D49L, 0x8CD37CF3L, 0xFBD44C65L,
   0x4DB26158L, 0x3AB551CEL, 0xA3BC0074L, 0xD4BB30E2L,
   0x4ADFA541L, 0x3DD895D7L, 0xA4D1C46DL, 0xD3D6F4FBL,
   0x4369E96AL, 0x346ED9FCL, 0xAD678846L, 0xDA60B8D0L,
   0x44042D73L, 0x33031DE5L, 0xAA0A4C5FL, 0xDD0D7CC9L,
   0x5005713CL, 0x270241AAL, 0xBE0B1010L, 0xC90C2086L,
   0x5768B525L, 0x206F85B3L, 0xB966D409L, 0xCE61E49FL,
   0x5EDEF90EL, 0x29D9C998L, 0xB0D09822L, 0xC7D7A8B4L,
   0x59B33D17L, 0x2EB40D81L, 0xB7BD5C3BL, 0xC0BA6CADL,
   0xEDB88320L, 0x9ABFB3B6L, 0x03B6E20CL, 0x74B1D29AL,
   0xEAD54739L, 0x9DD277AFL, 0x04DB2615L, 0x73DC1683L,
   0xE3630B12L, 0x94643B84L, 0x0D6D6A3EL, 0x7A6A5AA8L,
   0xE40ECF0BL, 0x9309FF9DL, 0x0A00AE27L, 0x7D079EB1L,
   0xF00F9344L, 0x8708A3D2L, 0x1E01F268L, 0x6906C2FEL,
   0xF762575DL, 0x806567CBL, 0x196C3671L, 0x6E6B06E7L,
   0xFED41B76L, 0x89D32BE0L, 0x10DA7A5AL, 0x67DD4ACCL,
   0xF9B9DF6FL, 0x8EBEEFF9L, 0x17B7BE43L, 0x60B08ED5L,
   0xD6D6A3E8L, 0xA1D1937EL, 0x38D8C2C4L, 0x4FDFF252L,
   0xD1BB67F1L, 0xA6BC5767L, 0x3FB506DDL, 0x48B2364BL,
   0xD80D2BDAL, 0xAF0A1B4CL, 0x36034AF6L, 0x41047A60L,
   0xDF60EFC3L, 0xA867DF55L, 0x316E8EEFL, 0x4669BE79L,
   0xCB61B38CL, 0xBC66831AL, 0x256FD2A0L, 0x5268E236L,
   0xCC0C7795L, 0xBB0B4703L, 0x220216B9L, 0x5505262FL,
   0xC5BA3BBEL, 0xB2BD0B28L, 0x2BB45A92L, 0x5CB36A04L,
   0xC2D7FFA7L, 0xB5D0CF31L, 0x2CD99E8BL, 0x5BDEAE1DL,
   0x9B64C2B0L, 0xEC63F226L, 0x756AA39CL, 0x026D930AL,
   0x9C0906A9L, 0xEB0E363FL, 0x72076785L, 0x05005713L,
   0x95BF4A82L, 0xE2B87A14L, 0x7BB12BAEL, 0x0CB61B38L,
   0x92D28E9BL, 0xE5D5BE0DL, 0x7CDCEFB7L, 0x0BDBDF21L,
   0x86D3D2D4L, 0xF1D4E242L, 0x68DDB3F8L, 0x1FDA836EL,
   0x81BE16CDL, 0xF6B9265BL, 0x6FB077E1L, 0x18B74777L,
   0x88085AE6L, 0xFF0F6A70L, 0x66063BCAL, 0x11010B5CL,
   0x8F659EFFL, 0xF862AE69L, 0x616BFFD3L, 0x166CCF45L,
   0xA00AE278L, 0xD70DD2EEL, 0x4E048354L, 0x3903B3C2L,
   0xA7672661L, 0xD06016F7L, 0x4969474DL, 0x3E6E77DBL,
   0xAED16A4AL, 0xD9D65ADCL, 0x40DF0B66L, 0x37D83BF0L,
   0xA9BCAE53L, 0xDEBB9EC5L, 0x47B2CF7FL, 0x30B5FFE9L,
   0xBDBDF21CL, 0xCABAC28AL, 0x53B39330L, 0x24B4A3A6L,
   0xBAD03605L, 0xCDD70693L, 0x54DE5729L, 0x23D967BFL,
   0xB3667A2EL, 0xC4614AB8L, 0x5D681B02L, 0x2A6F2B94L,
   0xB40BBE37L, 0xC30C8EA1L, 0x5A05DF1BL, 0x2D02EF8DL
};


U32 NIC_DEVICE_OBJECT::DeviceCalculateCRC32(PU8	ptrBuffer, int nLength)
{
   U32 Crc = 0xffffffff;

   while (nLength--) 
   {
      Crc = g_szCRCTable[(Crc ^ *ptrBuffer++) & 0xFF] ^ (Crc >> 8);
   }

   return ~Crc;

}
#endif


U32	NIC_DEVICE_OBJECT::DeviceCalculateCRC32(PU8	ptrBuffer, int nLength, BOOL bReverse)
{
    U32 	Crc, Carry;
    int		i, j;
    U8		CurByte;

    Crc = 0xffffffff;

    for (i = 0; i < nLength; i++) 
	{
        CurByte = ptrBuffer[i];

        for (j = 0; j < 8; j++) 
		{
            Carry = ((Crc & 0x80000000) ? 1 : 0) ^ (CurByte & 0x01);
            Crc <<= 1;
            CurByte >>= 1;
            if (Carry) 
			{
                Crc = (Crc ^ 0x04c11db6) | Carry;
            }
        }
    }

    for (i=0, Carry=0x0L; i < 32 ; i++) 
	{
       Carry <<= 1;
       if (Crc & 0x1) 
	   {
          Carry |= 0x1L;
       }
       Crc >>= 1;
    }
    return bReverse?~Carry:Carry;
}

/*******************************************************************************
 *
 * Device Attributes and Characteristics
 *
 ********************************************************************************/
PU8 NIC_DEVICE_OBJECT::GetMacAddress(PU8 ptrBuffer)
{
	if(!ptrBuffer) 
		return ptrBuffer;

	PU16	pcurr=(PU16)&
		m_btEeprom[m_dwEepromFiledPosition[EID_MAC_ADDRESS]];
	*(PU16)ptrBuffer = *pcurr++;
	*(PU16)(ptrBuffer+2) = *pcurr++;
	*(PU16)(ptrBuffer+4) = *pcurr++;
	return ptrBuffer;
}

WORD NIC_DEVICE_OBJECT::GetVendorID(void)
{
	return *(PWORD)(&m_btEeprom[m_dwEepromFiledPosition[EID_VENDOR_ID]]);
}

WORD NIC_DEVICE_OBJECT::GetProductID(void)
{
	return *(PWORD)(&m_btEeprom[m_dwEepromFiledPosition[EID_PRODUCT_ID]]);
}

void NIC_DEVICE_OBJECT::DeviceRegisterAdapter(void)
{
	int		attr=0;
	
	if(m_szConfigures[CID_BUS_MASTER])
		attr |= NDIS_ATTRIBUTE_BUS_MASTER;
		
	if(m_szConfigures[CID_INTERMEDIATE])
		attr = attr
			| NDIS_ATTRIBUTE_INTERMEDIATE_DRIVER
			//| NDIS_ATTRIBUTE_IGNORE_PACKET_TIMEOUT
			//| NDIS_ATTRIBUTE_IGNORE_REQUEST_TIMEOUT
			;
			
    NdisMSetAttributesEx(
		m_pUpper->GetNdisMiniportAdapterHandle(),	// miniport handle 
		(NDIS_HANDLE)m_pUpper,						// miniport context
		m_szConfigures[CID_CHECK_FOR_HANG_PERIOD],
		attr,
		(NDIS_INTERFACE_TYPE)m_szConfigures[CID_INTERFACE_TYPE]);
}

/*******************************************************************************
 *
 *
 ********************************************************************************/

void NIC_DEVICE_OBJECT::DeviceReportStatistics(U32 uEvent,U32 uValue)
{
	if(uEvent >= TID_SIZE) return;
	m_szStatistics[uEvent] += uValue;
}


void NIC_DEVICE_OBJECT::DeviceRetriveConfigurations(NDIS_HANDLE hConfig)
{
	NDIS_STATUS	status;
	PCONFIG_PARAMETER	pconfig;
	PNDIS_CONFIGURATION_PARAMETER	param;

	//SETFNAME("NIC_DEVICE_OBJECT::DeviceRetriveConfigurations()");
	//FUNCTION_ENTER_MSG();

	for(pconfig=GetConfigureParameters(); (pconfig->uId != (U32)-1); pconfig++)
	{
		NdisReadConfiguration(
			&status,
			&param,
			hConfig,
			&(pconfig->szName),
			NdisParameterHexInteger);
		if(status == NDIS_STATUS_SUCCESS)
			m_szConfigures[pconfig->uId] = 
				param->ParameterData.IntegerData;
		else
			m_szConfigures[pconfig->uId] = pconfig->uDefValue;
	}

	//FUNCTION_LEAVE_MSG();
}

void NIC_DEVICE_OBJECT::InitialDefaultSettings(void)
{
	//SETFNAME("NIC_DEVICE_OBJECT::InitialDefaultSettings()");
	//FUNCTION_ENTER_MSG();

	m_szConfigures[CID_CHIP_STEPPING] = 0;

	m_szConfigures[CID_INTERMEDIATE] = 0;
	m_szConfigures[CID_NEED_IO_SPACE] = 1;
	m_szConfigures[CID_NEED_INTERRUPT] = 1;
	
	m_szCurrentSettings[SID_PHY_NUMBER] = MII_INTERNAL_PHY_ADDR;
	m_szCurrentSettings[SID_HW_STATUS] = NdisHardwareStatusReady;
	m_szCurrentSettings[SID_MEDIA_SUPPORTED] = NdisMedium802_3;
	m_szCurrentSettings[SID_MEDIA_IN_USE] = NdisMedium802_3;

	m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS] = 
												// NdisMediaStateConnected;
												// SetConnectionStatus(false);
												   NdisMediaStateDisconnected;
	m_szCurrentSettings[SID_OP_MODE] = 0;
	
	m_szCurrentSettings[SID_MAXIMUM_LOOKAHEAD] = ETH_MAX_FRAME_SIZE;
	m_szCurrentSettings[SID_MAXIMUM_FRAME_SIZE] = ETH_MAX_FRAME_SIZE - ETH_HEADER_SIZE;
    m_szCurrentSettings[SID_MAXIMUM_TOTAL_SIZE] = ETH_MAX_FRAME_SIZE;
    m_szCurrentSettings[SID_BUFFER_SIZE] = DRIVER_BUFFER_SIZE;
    m_szCurrentSettings[SID_MAXIMUM_SEND_PACKETS] = 1;
	m_szCurrentSettings[SID_LINK_SPEED] = 100000;

	m_szCurrentSettings[SID_GEN_MAC_OPTIONS] =
		NDIS_MAC_OPTION_TRANSFERS_NOT_PEND
		| NDIS_MAC_OPTION_COPY_LOOKAHEAD_DATA
		| NDIS_MAC_OPTION_RECEIVE_SERIALIZED
		| NDIS_MAC_OPTION_NO_LOOPBACK;
	
	m_szCurrentSettings[SID_GEN_CURRENT_PACKET_FILTER] = 0; 
	m_szCurrentSettings[SID_GEN_TRANSMIT_BUFFER_SPACE] = 
		m_szConfigures[CID_TXBUFFER_NUMBER]
		* ETH_MAX_FRAME_SIZE;
	m_szCurrentSettings[SID_GEN_RECEIVE_BUFFER_SPACE] = 
		m_szConfigures[CID_RXBUFFER_NUMBER]
		* ETH_MAX_FRAME_SIZE;
	m_szCurrentSettings[SID_GEN_TRANSMIT_BLOCK_SIZE] = ETH_MAX_FRAME_SIZE;
	m_szCurrentSettings[SID_GEN_RECEIVE_BLOCK_SIZE] = ETH_MAX_FRAME_SIZE;
	m_szCurrentSettings[SID_GEN_CURRENT_LOOKAHEAD] = ETH_MAX_FRAME_SIZE;
	m_szCurrentSettings[SID_GEN_DRIVER_VERSION] = 
		(PRJ_NDIS_MAJOR_VERSION << 8) | PRJ_NDIS_MINOR_VERSION;
	m_szCurrentSettings[SID_GEN_VENDOR_DRIVER_VERSION] = 0x01010000; 
	m_szCurrentSettings[SID_GEN_PROTOCOL_OPTIONS] = 0;

	//FUNCTION_LEAVE_MSG();
}

void NIC_DEVICE_OBJECT::RegisterIoSpace(void)
{
	
}

void NIC_DEVICE_OBJECT::RegisterInterrupt(void)
{
	if(!m_szConfigures[CID_NEED_INTERRUPT]) return;

	NDIS_STATUS	status;
	if((status=NdisMRegisterInterrupt(
		&m_InterruptHandle,
		m_pUpper->GetNdisMiniportAdapterHandle(),
		m_szConfigures[CID_IRQ_NUMBER],	// or say, irq vector
		m_szConfigures[CID_IRQ_LEVEL],	// irql level
		TRUE,		// request ISR
		(BOOLEAN)m_szConfigures[CID_IRQ_SHARED],		// shared interrupt
		(KINTERRUPT_MODE)m_szConfigures[CID_IRQ_GEN_TYPE])) 
		!= NDIS_STATUS_SUCCESS
		)	
	{
		if (status==NDIS_STATUS_RESOURCE_CONFLICT)
			THROW((ERR_STRING("Error-STATUS_RESOURCE_CONFLICT - Error in registering interrupt\r\n"),status));
		else	
		if (status==NDIS_STATUS_RESOURCES)
			THROW((ERR_STRING("Error-NDIS_STATUS_RESOURCES - Error in registering interrupt\r\n"),status));
		else	
		if (status==NDIS_STATUS_FAILURE)
			THROW((ERR_STRING("Error-NDIS_STATUS_FAILURE - Error in registering interrupt\r\n"),status));
		else	
			THROW((ERR_STRING("Error-No_Know_Status - Error in registering interrupt\r\n"),status));
	}
}


void FileHexLog(U8 *pHEX, int k)
{
	if (!k) PRINTF(_T("-%02x"), pHEX[k]);
	else PRINTF(_T(" %02x"), pHEX[k]);
}
void FileCharLog(U8 *pCH, int k)
{
	if (!k) PRINTF(_T("%c"), '$');
	else if (pCH[k]==0 || pCH[k]==0x0a || pCH[k]==0x0d) 
	     PRINTF(_T("%c"), '.'); //_RPT_PutChar();
	else PRINTF(_T("%c"), pCH[k]); //_RPT_PutChar();
}		
void FileEditLine(int s, int e, U8 *btEeprom)
{
	int wr= e; //as 'lenDisp'
	int k;
	
	e= s + 15;
      //for (k=(n-15); k<=n; k++)
	for (k=s; k<=e; k++){
//.		if (k==(s+8)) PRINTF(_T("  ")); 
		if (k>wr) PRINTF(_T("   "));
		else FileHexLog(btEeprom,k); //btEeprom[i+k]  
	}
	PRINTF(_T(" ; "));  
	for (k=s; k<=e; k++)
	{
		if (k<wr)
	  	  FileCharLog(btEeprom,k); //btEeprom[i+k]
	}
	PRINTF(_T("\r\n"));
}

void FileEditBuffer(U8 *pszbuf, int size)
{
	int n;
	_RPT_STR(_T("[962 DUMP]: %d bytes\r\n"), size);
	for (n=0; n<size; n++){ 
		if ( !((n+1)%16) || n== size-1){
			_RPT_STR(_T("%08xh:"), (n/16)*16);
			FileEditLine((n/16)*16, n, pszbuf); // --pszbuf is (start byte)----> 
		}
	}
}

//Total 128 bytes= 64 WORDs
void NIC_DEVICE_OBJECT::DeviceReadGroupEeprom(EEPROM_DATA_TYPE *pcurr, int count, UINT useconds)
{
	int n;
	U16	highbyte,lowbyte;
	PRINTF(_T("962 EEPROM wait: %d us\r\n"), useconds);
	for (n=0; n<count; n++)
	{
		// issue EEPROM read command<2>
		DeviceWritePort(DM9_EPADDR,n);
		DeviceWritePort(DM9_EPCNTL,MAKE_MASK(2));
		
		// wait until status bit<0> cleared
		//DevicePolling(DM9_EPCNTL,MAKE_MASK(0),0x00);=
		  // v2.55
  			//NdisMSleep(uSec300); // 300 uSec
  		  // v2.91
  		  	NdisStallExecution(useconds); 
	
		// retrive data
		DeviceWritePort(DM9_EPCNTL,0);
		lowbyte  = (WORD)DeviceReadPort(DM9_EPLOW);
		highbyte = (WORD)DeviceReadPort(DM9_EPHIGH);
		
	  	//return MAKE_WORD(lowbyte,highbyte);
  		  // v2.91
		  	*pcurr++ = MAKE_WORD(lowbyte,highbyte);
	}
}
void NIC_DEVICE_OBJECT::DeviceWriteGroupEeprom(EEPROM_DATA_TYPE *pcurr, int count, UINT useconds)
{
	//int n;
	PRINTF(_T("962 EEPROM wait: %d us (Correction-Write-EP3 intinterval: 0x%02x) \r\n"), useconds, *pcurr&0xff);
	//for (n=0; n<count; n++)
	//{
		// assign the register offset
		DeviceWritePort(DM9_EPADDR, 12); //uWordAddress

		// put data
		DeviceWritePort(DM9_EPLOW, LOW_BYTE(*pcurr));
		DeviceWritePort(DM9_EPHIGH,HIGH_BYTE(*pcurr));
		
		// issue EEPROM write enable<4> and write command<1>
		DeviceWritePort(DM9_EPCNTL,MAKE_MASK2(4,1));
		
		// wait until status bit<0> cleared
		//DevicePolling(DM9_EPCNTL,MAKE_MASK(0),0x00);=
		  // v2.55
  			//NdisMSleep(uSec300); // 300 uSec
  		  // v2.91
  		  	NdisStallExecution(useconds); 
	
		// stop command
		DeviceWritePort(DM9_EPCNTL,0);
	//}
	return;
}

#define WD_COUNT_EE	8
void NIC_DEVICE_OBJECT::LoadEeprom(void)
{
	int		n, ns, sv_n; //, k
	EEPROM_DATA_TYPE	*pcurr=(EEPROM_DATA_TYPE*)&m_btEeprom[0];
	//EEPROM_DATA_TYPE	eedata;
	int str_waddr1,str_waddr2,str_waddr3;
	int i,lenDisp,len1,len2,len3;

	_RPT_STR(_T("962 EEPROM read: \r\n"));
	
//Total 128 bytes= 64 WORDs
	if(!m_mutexEEPROM.TryLock()) {
		PRINTF(_T("962 LoadEeprom fail! oxoxoxoxoxox! \r\n"));
		return;
	}
	DeviceReadGroupEeprom(pcurr, 64, uSec1); //uSec1,uSec5, uSec10,uSec45
	m_mutexEEPROM.Release();
#if 1
//Must be EP3 interrupt interval be very fast, default 0x0b,  tobe 0x01, or 0x00
//Total 2 bytes= 1 WORD, WORD12
	if(!m_mutexEEPROM.TryLock()) {
		PRINTF(_T("962 WrEeprom fail! oxoxoxoxoxox! \r\n"));
		return;
	}
	if ((m_btEeprom[24]&0x0f)>0x0B)
	{
	    EEPROM_DATA_TYPE wcurr= 0x0B | m_btEeprom[25] << 8; //m_btEeprom[24] | m_btEeprom[25] << 8;
	    DeviceWriteGroupEeprom(&wcurr, 1, uSec45);
	}
	m_mutexEEPROM.Release();
#endif
//Display 64 WORDs' operation	
    for(ns= n=32;n<64;n++) // ns= n=0, (DIM(m_btEeprom)/sizeof(EEPROM_DATA_TYPE))
	{
		//if (n<16) _RPT_PutChar(' .'); 
		if (n==0 || n==16 || n==32 || n==48)  
        {
			if (n==ns) ;
			else PRINTF(_T("\r\n")); //_RPT_NextLine();
        }

		if (n==32 || n==48) _RPT_STR(_T("#.")); 
		else if (n==(32+8) || n==(48+8)) _RPT_STR(_T("&.")); 
		else _RPT_STR(_T(" .")); 

	      //eedata= DeviceReadEeprom(n); -by 'DeviceReadGroupEeprom()'
	      //*pcurr++ = eedata;

	} // of for offset n
	_RPT_NextLine();

	pcurr=(EEPROM_DATA_TYPE*)&m_btEeprom[0];
	_RPT_STR(_T("962 USB_EE:"));
	for (n=0; n<WD_COUNT_EE; n++)
	{
		if (!(n%4)) _RPT_NextLine();
		_RPT_STR(_T(" \t EEP[%02x]=%04x"), n, *pcurr++); // \t EEP[%02x]=%04x \t EEP[%02x]=%04x
	}
	_RPT_NextLine();

	_RPT_STR(_T("962 STR_TBL: \r\n"));
	str_waddr1=(*pcurr & 0xff);
	len1=(*pcurr >> 8);
	pcurr++;
	str_waddr2=(*pcurr & 0xff);
	len2=(*pcurr >> 8);
	pcurr++;
	str_waddr3=(*pcurr & 0xff);
	len3=(*pcurr >> 8);
	pcurr++;
	_RPT_STR(_T(" \t str1 word_addr: %02x"), str_waddr1); 
	_RPT_STR(_T(" \t len: 0x%x bytes"), len1); 
	_RPT_NextLine();
	
	_RPT_STR(_T(" \t str2 word_addr: %02x"), str_waddr2); 
	_RPT_STR(_T(" \t len: 0x%x bytes"), len2); 
	_RPT_NextLine();

	_RPT_STR(_T(" \t str3 word_addr: %02x"), str_waddr3); 
	_RPT_STR(_T(" \t len: 0x%x bytes"), len3);  
	_RPT_NextLine();

//	_RPT_STR(_T("962 USB_CTRL: \r\n"));
	_RPT_STR(_T(" \t max power= 0x%02x * 2ma"), *pcurr & 0xff); 
	_RPT_STR(_T(" \t USB class code(meaningless)= 0x%02x "), *pcurr >> 8); 
	_RPT_NextLine();
	pcurr++;
	
	_RPT_STR(_T(" \t Bit 3:0 EP3 Interrupt interval (default:0Bh)= 0x%04x"), *pcurr); 
	_RPT_NextLine();
	pcurr++;

//	_RPT_STR(_T("962 STR_1:  \r\n"));
	//pcurr= (EEPROM_DATA_TYPE*)&m_btEeprom[str_waddr1*2];
	i= str_waddr1*2;
	lenDisp= len1;
		//param: i
		//param: lenDisp= len1
			for (n=0, sv_n= 0; n<lenDisp; n++){
				if ( !((n+1)%16) ){
					FileEditLine(n-15, n, &m_btEeprom[i]);
					sv_n= n+1;
				}
			}
			if (n != sv_n){
				FileEditLine(sv_n, lenDisp, &m_btEeprom[i]);  // 'lenDisp' may be shorter then 16 bytes
				
				/*
				for (k=sv_n; k<=(sv_n+15); k++){ //lenDisp
					if (k==(sv_n+8)) FileWriteLog(1,"  ");
					if (k>=lenDisp) FileWriteLog(1,"   ");
					else FileHexLog(m_btEeprom[i+k]);  
				}
				FileWriteLog(1,"  ;");  
				for (k=sv_n; k<=(sv_n+15); k++) //lenDisp
				{
					//if (k>=lenDisp) FileWriteLog(1," ");
					//else ;
					if (k<lenDisp)
					  FileCharLog(m_btEeprom[i+k]);
				}
				FileWriteLog(1, "\r\n"); */
			}

//	_RPT_STR(_T("962 STR_2:  \r\n"));
	//pcurr= (EEPROM_DATA_TYPE*)&m_btEeprom[str_waddr2*2];
	i= str_waddr2*2;
	lenDisp= len2;
		//param: i
		//param: lenDisp= len2
			for (n=0, sv_n= 0; n<lenDisp; n++)
				if ( !((n+1)%16) ){
					FileEditLine(n-15, n, &m_btEeprom[i]);
					sv_n= n+1;
				}
			if (n != sv_n)
				FileEditLine(sv_n, lenDisp, &m_btEeprom[i]);
	
//	_RPT_STR(_T("962 STR_3:  \r\n"));
	//pcurr= (EEPROM_DATA_TYPE*)&m_btEeprom[str_waddr3*2];
	i= str_waddr3*2;
	lenDisp= len3;
		//param: i
		//param: lenDisp= len3
			for (n=0, sv_n= 0; n<lenDisp; n++)
				if ( !((n+1)%16) ){
					FileEditLine(n-15, n, &m_btEeprom[i]);
					sv_n= n+1;
				}
			if (n != sv_n)
				FileEditLine(sv_n, lenDisp, &m_btEeprom[i]);

	// Raw
	_RPT_STR(_T("962 EepromData:\r\n"));
	//pcurr=(EEPROM_DATA_TYPE*)&m_btEeprom[0];
	//for (n=0; n<64; n++) // Total:64, n<13, n<64
	//{
	//	if (!(n%16)) _RPT_STR(_T("\r\n %04X"), *pcurr++); //_RPT_NextLine();
	//	else if (!(n%8)) _RPT_STR(_T("  %04X"), *pcurr++); //_RPT_PutChar(' ');
	//	else if (!(n%4)) _RPT_STR(_T(".%04X"), *pcurr++); //_RPT_PutChar('.'); 
	//	else  _RPT_STR(_T(" %04X"), *pcurr++);
	//}
	//_RPT_NextLine();
	FileEditBuffer(&m_btEeprom[0], EEPROM_93C46_SIZE);

//
 //(+)20080124 By Joseph
	//DEBUG_PRINTF(_T(" ==============================================\r\n"));
	//DEBUG_PRINTF(_T(" Davicom Semiconductor, Inc.\r\n"));
	//DEBUG_PRINTF(_T(" LoadEEPROM()\r\n"));
	//DEBUG_PRINTF(_T(" ----------------------------------------------\r\n"));
//	_RPT_STR(_T("mode_962 SROM: "));
//	for (n=0;n<1;n++) _RPT_STR(_T("%02X "), n);
//	for (n=1;n<8;n++) _RPT_STR(_T("-- "), n);
//	_RPT_PutChar(' ');
//	for (n=8;n<15;n++) _RPT_STR(_T("-- "), n);
//	for (n=15;n<16;n++) _RPT_STR(_T("%02X "), n);
//	_RPT_NextLine();

//	_RPT_STR(_T("mode_962 DATA: "));
//	for (n=0;n<8;n++) _RPT_STR(_T("%02X "), m_btEeprom[n]);
//	_RPT_PutChar(' ');
//	for (n=8;n<16;n++) _RPT_STR(_T("%02X "), m_btEeprom[n]);
//	_RPT_NextLine();
	//DEBUG_PRINTF(_T(" ==============================================\r\n"));
 //(-)20080124 By Joseph
//
#if 0	
	DeviceCalculateCRC32(&m_btEeprom[0],DIM(m_btEeprom)-2);
	
	AssignDummyMacAddress(); // assign a dummy MAC address
#endif	
}

BOOL NIC_DEVICE_OBJECT::DevicePolling(
	U32		uPort,    
	U32		uMask,     //(1<<0)
	U32		uExpected, // 0x00
	U32		uInterval, // 20    /* in millisecond */
	U32		uRetries)  // -1
{
  #if 0
  // -1
	for(;uRetries;uRetries--)
	{
		if((DeviceReadPort(uPort) & uMask) == uExpected) break;
		NdisStallExecution(uInterval);
	} // of retry loop
	
	return (BOOL)uRetries;
  #else
  // v2.55
  	NdisMSleep(uSec300); // 300 uSec
  	return 0;
  #endif
}

void NIC_DEVICE_OBJECT::SetConnectionStatus(bool bConnected)
{
  //U32 flow;
	//PRINTF(_T("  .SetConnectionStatus bConnected(%d) while m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS](%d)\r\n"), bConnected, m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS]);
	if (bConnected)
	{
		if (m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS] == NdisMediaStateConnected)
			;
		else
		{
		PRINTF(_T("  .Set bConnected(%d) while on mediaDiscnnted\r\n"), bConnected);
		PRINTF(_T("  .Send connection!\r\n"));
		PRINTF(_T("~\r\n"));
  //flow= DeviceReadPort(DM9_FLOW);
  //PRINTF(_T("REG0AH (%x)= %02x\r\n"), flow, flow);
		PRINTF(_T("\r\n"));
		m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS] = NdisMediaStateConnected;
		NdisMIndicateStatus(m_pUpper->GetNdisMiniportAdapterHandle(), NDIS_STATUS_MEDIA_CONNECT,
                 			(PVOID) 0, 0);
		NdisMIndicateStatusComplete(m_pUpper->GetNdisMiniportAdapterHandle());
		}
	}
   	else
	{
		if (m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS] == NdisMediaStateDisconnected)
			;
		else
		{
		PRINTF(_T("  .Set bConnected(%d) while on mediaCnnted\r\n"), bConnected);
		PRINTF(_T("  .Send disconnection!\r\n"));
  //flow= DeviceReadPort(DM9_FLOW);
  //PRINTF(_T("REG0AH (%x)= %02x\r\n"), flow, flow);
		PRINTF(_T("\r\n"));
		m_szCurrentSettings[SID_MEDIA_CONNECTION_STATUS] = NdisMediaStateDisconnected;
		NdisMIndicateStatus(m_pUpper->GetNdisMiniportAdapterHandle(), NDIS_STATUS_MEDIA_DISCONNECT,
			                (PVOID) 0, 0);
		NdisMIndicateStatusComplete(m_pUpper->GetNdisMiniportAdapterHandle());
		}
	}

//;	LinkState_Get_DSCSR_EX(_T("CheckForHang].[Link-Change"), _T("PHYReg17"), 17); // DSCSR//OutputMessageW
}

WORD NIC_DEVICE_OBJECT::DeviceCheckLink(void) //  Device-Check-For-Link() ;'BMSR'
{
	WORD wLinkState= 0; //,  wData;
	U32 nsr; //,  ncr;

	BOOL MAC; // PHY, 

	//PRINTF(_T("   .In.DeviceCheckLink \r\n"));

 //	wLinkState= LinkState_Get_BMSR(0x01);
	nsr= DeviceReadPort(DM9_NSR);

//	PHY= (wLinkState&0x0004); 
	MAC= (nsr & MAKE_MASK(6));

	//PRINTF(_T("   .DeviceCheckLink MAC(0x%x) \r\n"), MAC);
	
	SetConnectionStatus( MAC ?true :false ); //(PHY && MAC); //(true);
	if (MAC) //(PHY && MAC)
	{
		m_Counter++;
		wLinkState= 0x0004;
	}
	else //if (!PHY && !MAC)
	{
		m_Counter_Fail++;
	}
	//else
	//	m_Counter_Mix++;
	
	//if (PHY && MAC)
	//	_RPT_STR(_T("LnkOn-     "));
	//else
	//	_RPT_STR(_T("Lnk-Fail-  "));
	
	//ncr= DeviceReadPort(DM9_NCR); 
	//wData= DeviceReadPhy(0, MIIADDR_SPSTAT); // 17
	//_RPT_STR(_T("[NCNSPHY17:%02X,%02X,%04X] "), 
	//				ncr,
	//				nsr,
	//				wData);

	//if (PHY) // 0x01:dummy for BMSR-01
	//	_RPT_STR(_T("On(PHY@ %d, %d) &&"),m_Counter,m_Counter_Fail);
	//else
	//	_RPT_STR(_T("Fail(PHY@ %d, %d) &&"),m_Counter,m_Counter_Fail);


	//if(MAC)
	//	_RPT_STR(_T("On(NSR@ %d,%d,[neq:%d])"),m_Counter,m_Counter_Fail,m_Counter_Mix);
	//else
	//	_RPT_STR(_T("Fail(NSR@ %d,%d,[NEQ:%d])"),m_Counter,m_Counter_Fail,m_Counter_Mix);

	//_RPT_NextLine();

	//if (PHY && MAC){
	//	LnkStat_GetLinkStatus();
	//	LnkStat_GetLinkStatus();
	//}

	return wLinkState;
}

// USBDeviceAttach re_code

// Refer: "USBDeviceAttach.cpp"
//
// Call: if (DriverEntryNewObj==0) return (*fAcceptControl=FALSE);
//       if (!g_hNdisIntermediateHandle) return (*fAcceptControl=FALSE);
//	 if (!USBDeviceAttach_re_code(hDevice, lpUsbFuncs, lpInterface))
//		return (*fAcceptControl=FALSE);
//       return (*fAcceptControl=TRUE);
//
BOOL USBDeviceAttach_re_code(
	USB_HANDLE 			hDevice, 
	LPCUSB_FUNCS			lpUsbFuncs, 
	LPCUSB_INTERFACE 		lpInterface)
{
	LPCUSB_DEVICE pusbdev;
	pusbdev= g_lpUsbDevice;
	PRINTF(_T("  - - - re_code ( bcdUSB: 0x%04x\r\n"), pusbdev->Descriptor.bcdUSB);
	//PRINTF(_T("-  - - - re_code ( bcdUSB: 0x%04x\r\n"), pusbdev->Descriptor.bcdUSB);
	//PRINTF(_T("-  - - - re_code ( VID: %x\r\n"), pusbdev->Descriptor.idVendor);
	//PRINTF(_T("-  - - - re_code ( PID: %x\r\n"), pusbdev->Descriptor.idProduct);
	//PRINTF(_T("-  - - - re_code ( bDescriptorType: 0x%x\r\n"), pusbdev->Descriptor.bDescriptorType);
	//PRINTF(_T("-  - - - re_code ( bNumConfigurations: %d\r\n"), pusbdev->Descriptor.bNumConfigurations);
	return TRUE ;
}

BOOL NIC_DEVICE_OBJECT::DeviceCheckForHang(void)
{
	WORD wLinkState;
	int i, enter= 0;

//	PRINTF(_T(" .DeviceCheckForHang.s \r\n"));
	
// V270 --Unstable or un-plug before detached can be run 
	if ((DM96_VENDOR_CHIP_ID & 0xff) != DeviceReadPort(DM9_VIDLOW)   // 0x28
	 || (DM96_VENDOR_CHIP_ID >> 8 ) != DeviceReadPort(DM9_VIDHIGH))  // 0x29
	{
		
	        m_Counter_detch++;
	      //PRINTF(_T("DM962 L\r\n")); // means lose USB chip registers in read
                PRINTF(_T("  .ForHng.s -DM96 L ,hng_detch, Count(%d)\r\n"), m_Counter_detch);
	    
	        USBDeviceAttach_re_code(g_hDevice, g_lpUsbFuncs, NULL);
                return TRUE; 
		//return FALSE;
	}

	m_CHIPMsgCtrl= FALSE; //TRUE; // KEEP TRUE

	//PRINTF(_T("  .DeviceCheckForHang -> before DeviceCheckLink\r\n"));
	wLinkState= DeviceCheckLink(); // Device-Check-For-Link()
	//PRINTF(_T("  .DeviceCheckForHang wLinkState(%x) m_wLinkState(%x)\r\n"), wLinkState, m_wLinkState);	
	//[.PrintMessageCtrl(wLinkState);]

	// ; [Supplement]
	if (!(wLinkState & 0x4))
	{
//mode_962 		_RPT_STR(_T("[DISCONNECT===][SetAutoMDIX]\r\n"));

		DeviceWritePort(0x1f, 0x01); 
		NdisMSleep(mSec5); // 5 ms
		DeviceWritePort(0x1f, 0x00); 
		NdisMSleep(mSec10); // 10 ms

//mode_962 		_RPT_STR(_T(" [Restart Auto-Negotiation] \r\n"));
		DeviceWritePhy(0, 0, 0x3300); //1000 or 3100(default) AUTO (N-WAY)+Auto_Restart
		LinkState_LinkUp(AUTO_MDIX_MODE); //// ; [Return to Auto-MDIX]
	}

#if 0
	if (m_wLinkState != wLinkState)
	{	
		if (wLinkState & 0x4)
			SetConnectionStatus(true);
		else
    		SetConnectionStatus(false);
	}
#endif

	PrintMessageCtrl(wLinkState&0x4); //DEBUG_PRINTF(TEXT("[CkForHang]: Link=%d\r\n"), (wLinkState&0x4)); //

	m_wLinkState = wLinkState;

	U32	cr= DeviceGetReceiveStatus();
	U32	rxps,rxci;
	
	rxps = cr >> 31;
	rxci = cr & 0x7FFFFFFF;

	REPORT(TID_NIC_RXPS,rxps);	
	REPORT(TID_NIC_RXCI,rxci);	

#ifndef	IMPL_RESET
	return FALSE;
#endif

	//PRINTF(_T("  .DeviceCheckForHang 99999999999\r\n"));
	U32	lastread = m_szLastStatistics[TID_GEN_RCV_OK];
	U32	lastsent = m_szLastStatistics[TID_GEN_XMIT_OK];

	memcpy(
		(void*)&m_szLastStatistics,
		(void*)&m_szStatistics,
		sizeof(m_szStatistics));

	// report hang if 
	// 1. receive count stalled but overflow, or
	if((m_szStatistics[TID_GEN_RCV_OK] == lastread) && cr) 
	{
		//In the same time: Chip_ID check
		PRINTF(_T("\r\n"));
		PRINTF(_T("~\r\n"));
		GetChipID(); // V270, find chipid


		PRINTF(_T("mode_962 dm9usb:receive count stalled but overflow\r\n"));
		//	mac - reset  ??? 
		//	Phy -Reset (_DeviceWritePhy(0,0,0x8000); @ DM9ISA::InitialHardware)
		//
	#if 0	
		return TRUE;
	#endif
		//PRINTF(_T("mode_962 dm9usb:receive count stalled but overflow\r\n"));
		//PRINTF(_T("mode_962 dm9usb:receive count stalled but overflow\r\n"));
		//PRINTF(_T("mode_962 dm9usb:receive count stalled but overflow\r\n"));
		PRINTF(_T("mode_962  . \r\n"));
		PRINTF(_T("mode_962  . \r\n"));
		PRINTF(_T("mode_962  . \r\n"));
		PRINTF(_T("mode_962  . \r\n"));
		PRINTF(_T("mode_962  . \r\n"));
		
		return TRUE;
	#if 0
		return FALSE ;
	#endif
	}
	
	// 2. tx idle while tqueue out of resource
	if(m_pUpper->DriverIsOutOfResource() &&
		(DeviceHardwareStatus() & NIC_HW_TX_IDLE) ) 
	{
		PRINTF(_T("[dm9usb:tx idle while tqueue out of resource\r\n"));
		return TRUE;
	}
	//PRINTF(_T(" .DeviceCheckForHang \r\n"));
	if (wLinkState & 0x4) {
		if (!(m_Counter%100)) PRINTF(_T("  .ForHng.e 999 Up Count(%d)\r\n"),m_Counter);
	} else { if (!(m_Counter_Fail%100)) PRINTF(_T("  .DeviceCheckForHang.e 99999 Down Count(%d)\r\n"),m_Counter_Fail);
	}
	
	//JJDBG_Print, Step-4 "Show Info and determine re-cycle"
	//i= 0;
	//while (cLenCt[i])	{
	for (i=0; i< N_DBGCAP; )
	{
		if (cLen[i]) {
			enter= 1;
			PRINTF(_T("  .HngDBG%d %3d, PktCt %d"), i+1, cLen[i], cLenCt[i]);	
			if (!cLenCt[i+1]) PRINTF(_T("  )\r\n"));
			else  PRINTF(_T("\r\n"));
		}

		cLen[i]= 0;
		cLenCt[i]= 0;
		i++;

	}
		#if 1
		if (enter)
		{
		 //Li= 0; //sLen= 0; You can advoid clear operation here, to be [0]..[8] only if exhaust. It means not re-cycle!
		 //Li++;
		 Li= 0;
		}
		#endif

	//	#if 0
	//	 Li= 0; //sLen= 0; You can advoid clear operation here, to be [0]..[8] only if exhaust. It means not re-cycle!
	//	#endif
	//}

	return FALSE;
}

/*******************************************************************************
 *
 * Device timer routine
 *
 ********************************************************************************/

extern "C" void	DeviceTimerTrunkRoutine(
    IN PVOID SystemSpecific1,
    IN PVOID FunctionContext,
    IN PVOID SystemSpecific2,
    IN PVOID SystemSpecific3)
{
	NIC_DEVICE_OBJECT	*dev = (NIC_DEVICE_OBJECT*)FunctionContext;

	if(!dev->m_mutexTimer.TryLock()) return;
	dev->DeviceOnTimer();
	dev->m_mutexTimer.Release();
}


void NIC_DEVICE_OBJECT::DeviceInitializeTimer(void)
{
	//SETFNAME("NIC_DEVICE_OBJECT::DeviceInitializeTimer");
	//FUNCTION_ENTER_MSG();
	NdisMInitializeTimer(
		&m_timerObject,
		m_pUpper->GetNdisMiniportAdapterHandle(),
		(PNDIS_TIMER_FUNCTION)DeviceTimerTrunkRoutine,
		(PVOID)this);
	//FUNCTION_LEAVE_MSG();
}

void NIC_DEVICE_OBJECT::DeviceCancelTimer(void)
{
	BOOLEAN	result;
	NdisMCancelTimer(&m_timerObject, &result);
}

void NIC_DEVICE_OBJECT::DeviceSetTimer(U32 milliseconds)
{
	//SETFNAME("NIC_DEVICE_OBJECT::DeviceSetTimer");
	//FUNCTION_ENTER_MSG();
	//PRINTF(_T("[dm9usb:milliseconds = %d\n"),milliseconds);
	NdisMSetTimer(&m_timerObject,milliseconds);
	//FUNCTION_LEAVE_MSG();
}

void NIC_DEVICE_OBJECT::DeviceOnTimer(void)
{
}

void NIC_DEVICE_OBJECT::DeviceEnableTransmit(void)
{
}

void NIC_DEVICE_OBJECT::DeviceDisableTransmit(void)
{
}


// device attributes or characteristics

BOOL NIC_DEVICE_OBJECT::DeviceQueryInformation(
		OUT NDIS_STATUS		*Status,
		IN NDIS_OID		Oid,
		IN PVOID		InfoBuffer, 
		IN ULONG		InfoBufferLength, 
		OUT PULONG		BytesWritten,
		OUT PULONG		BytesNeeded)
{ 
	return FALSE; 
}

BOOL NIC_DEVICE_OBJECT::DeviceSetInformation(
		OUT NDIS_STATUS		*Status,
		IN NDIS_OID		Oid,
		IN PVOID		InfoBuffer, 
		IN ULONG		InfoBufferLength, 
		OUT PULONG		BytesRead,
		OUT PULONG		BytesNeeded)
{ 
	return FALSE; 
}


U32 NIC_DEVICE_OBJECT::DeviceHardwareStatus(void) 
{ 
	return NIC_HW_OK; 
}


void NIC_DEVICE_OBJECT::DeviceIndication(U32 dwIndication)
{
	m_pUpper->DriverIndication(dwIndication);
}

void NIC_DEVICE_OBJECT::DeviceSendCompleted(PCQUEUE_GEN_HEADER pObject)
{
	m_pUpper->DriverSendCompleted(pObject);
}

void NIC_DEVICE_OBJECT::DeviceReceiveIndication(int	nCurr, PVOID pVoid, int	nLength)
{
	m_pUpper->DriverReceiveIndication(nCurr,pVoid,nLength);
}



void NIC_DEVICE_OBJECT::InitialUsbParameters(USB_HANDLE pHandle,LPCUSB_FUNCS lpFunctions,LPCUSB_INTERFACE lpInterface)
{

}


void NIC_DEVICE_OBJECT::InitialConfigurations(NDIS_HANDLE hWrapperConfiguration)
{
	NDIS_STATUS		status;
	NDIS_HANDLE		hConfig;

	SETFNAME("NIC_DEVICE_OBJECT::InitialConfigurations()");
	//FUNCTION_SHRINK_MSG();
	//.FUNCTION_ENTER_MSG();


	// Read registry configurations
	NdisOpenConfiguration(&status, &hConfig, hWrapperConfiguration);

	if(status != NDIS_STATUS_SUCCESS) 
		THROW((ERR_STRING("NIC_DEVICE_OBJECT::InitialConfigurations - Error in opening configuration\r\n"),status));

	CException	*pexp;	
	TRY
	{
		InitialDefaultSettings();
		InitialEepromFieldPosition();
		DeviceRetriveConfigurations(hConfig);
		ValidateConfigurations();
		FI;
	}
	CATCH(pexp)
	{
		pexp->PrintErrorMessage();
		CLEAN(pexp);
		NdisCloseConfiguration(hConfig);
		THROW((ERR_STRING("NIC_DEVICE_OBJECT::InitialConfigurations - Error in retriving configurations.\r\n")));
	}
	NdisCloseConfiguration(hConfig);
	//.FUNCTION_LEAVE_MSG();
}
void NIC_DEVICE_OBJECT::RegisterConfigurations()
{
	//LARGE_INTEGER   TS, TE, TD; 
	//WORD cnt;
	//int be1000;
	U32 rdat;
	WORD wPHYID1;
	WORD wPHYID2;
	CException	*pexp;
	int loopc= 0;
	//DECNAME();
  //U32 flow;
    DWORD dat91H;

	PRINTF(_T("RegisterConfigurations 777777777777\r\n"));
	
	TRY
	{
		//REFNAME("1 of 5- ");
		//FUNCTION_ENTER_MSG();
		RegisterIoSpace();
		//FUNCTION_LEAVE_MSG();
		//REFNAME("2 of 5- ");
		//FUNCTION_ENTER_MSG();
		
		//DM9620/21 state info...
                dat91H= 0x80;
#if 1
                dat91H &= 0xF7;
		_RPT_STR(_T("962 Set D[3]: Disable multi-RX mode\r\n"));
#else
                dat91H |= 0x8;
		_RPT_STR(_T("962 Set D[3]: multi-RX mode\r\n"));
#endif
		DeviceWritePort(DM9_REG91H, dat91H);

		rdat= DeviceReadPort(DM9_REG91H);
		_RPT_STR(_T("962 Set Dat: 91H %02x\r\n"), rdat);
		if (rdat&0x80) _RPT_STR(_T("962 D[7]: RX header: %d bytes\r\n"), 4);
		else _RPT_STR(_T("962 D[7]: 0 (RX header: %d bytes)\r\n"), 3);
		if (rdat&0x20) _RPT_STR(_T("962 D[5]: USB descriptor CDC\r\n"));
		else _RPT_STR(_T("962 D[5]: 0\r\n"));
		if (rdat&0x10) _RPT_STR(_T("962 D[4]: CDC mode\r\n"));
		else _RPT_STR(_T("962 D[4]: 0\r\n"));
		if (rdat&0x08) _RPT_STR(_T("962 D[3]: multi-RX mode\r\n"));
		else _RPT_STR(_T("962 D[3]: 0\r\n"));
		if (rdat&0x04) _RPT_STR(_T("962 D[2]: multi-TX mode\r\n"));
		else _RPT_STR(_T("962 D[2]: 0\r\n"));
		wPHYID1= DeviceReadPhy(0,2);
		wPHYID2= DeviceReadPhy(0,3);
		_RPT_STR(_T("962 PHYID: %04X %02X '%X' %X\r\n"), wPHYID1, wPHYID2>>8, wPHYID2>>4 & 0x3f, wPHYID2 & 0xf);

		LoadEeprom(); 
		//FUNCTION_LEAVE_MSG();
	//REFNAME("3 of 5- ");
	//FUNCTION_ENTER_MSG();
		InitialHardware(m_nResetCounts=0);
	//FUNCTION_LEAVE_MSG();
		RegisterInterrupt();
		FI;
	}

	CATCH(pexp)
	{
		pexp->PrintErrorMessage();
		CLEAN(pexp);
	//FUNCTION_LEAVE_MSG(); // supplement for TRY {} above

		THROW((ERR_STRING("::RegisterConfigurations - Device error\r\n")));
	}

	// {No-way when CATCH() above}
	PRINTF(_T("RegisterConfigurations 888888888888\r\n"));
	
	//cnt= 0; be1000= 0;
	//TD.QuadPart= 0;
	//NdisGetCurrentSystemTime(&TS); //then = GetTimes();
	
	while (1) {
		//cnt++;
		
		//if (cnt==115) { // cnt==115 0ms,  
		//	            // cnt==230 || cnt==232 1000ms
		//  PRINTF(_T("RegisterCnfgtns.ones  exe counter %d"), cnt);
		//  PRINTF(_T(", [%dms] \r\n"), TD.QuadPart);
		//}
		
		//if (TD.QuadPart>1000 && !be1000) {
		//  be1000= 1;    // cnt==394 2000ms
		//  PRINTF(_T("RegisterCnfgtns.II  exe counter %d"), cnt);
		//  PRINTF(_T(", [%dms] \r\n"), TD.QuadPart);
		//}
		NdisMSleep(mSec1); // yes.log & no.log [msleep()]
		NdisMSleep(mSec1); // 1 ms
		loopc++;
		
		if (loopc>=642)
		//NdisGetCurrentSystemTime(&TE);
		//TD.QuadPart = TE.QuadPart - TS.QuadPart;
		//TD.QuadPart /= 10000;   // Convert to ms
		//if (TD.QuadPart>2000)	/* 2sec */
			break;
	}
	                    // cnt==642 3000ms
	//PRINTF(_T("RegisterCnfgtns.III  exe counter %d"), cnt);
	//PRINTF(_T(", [%dms] \r\n"), TD.QuadPart);

	PRINTF(_T("RegisterCnfgtns, Total loop: %d\r\n"), loopc);
	
	PRINTF(_T("RegisterConfigurations 888888888888\r\n")); //(2sec)
#if 0 	
//	DeviceCheckLink();
#endif
	DeviceOnSetupFilter(0);
	//REFNAME("5 of 5- ");
	//FUNCTION_ENTER_MSG();
	//FUNCTION_LEAVE_MSG();
	DeviceCheckLink();
	PRINTF(_T("RegisterConfigurations 99999999999\r\n"));
}

BOOL NIC_DEVICE_OBJECT::AssignDummyMacAddress()
{
	int	temp =0,n;
	int nPos = (int)m_dwEepromFiledPosition[EID_MAC_ADDRESS];	// Mac address offset (BYTE)

	for (n=0; n<6; n++)
		temp +=m_btEeprom[n];

  //if ( ( (temp==0) || (temp == (0xff * 6)) ) && (nPos >=0))
	if ( ( (temp==0) || (temp == (0xff * 6)) ) && (nPos >=0))
	{
		//for(n=0; n<6; n++)
		//	m_btEeprom[nPos+n]=n*0x11;
		for(n=0; n<6; n++)
			m_btEeprom[n]=n*0x11;
		return TRUE;
	}
	return FALSE;
}

BOOL NIC_DEVICE_OBJECT::DeviceQueryTxResources(void)
{
	return TRUE;
}
